package org.jgroups.util;

import org.jgroups.Message;

import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * Concurrent queue containing messages. When the max capacity is reached, producers will block until the capacity
 * drops below the max capacity. The max capacity and size of the queue is defined as the accumulated length of
 * the messages. Null messages are not permitted.
 * @author Bela Ban
 * @version $Id$
 */
public class MessageTransferQueue {
    private final java.util.Queue queue=new ConcurrentLinkedQueue<Message>();
    private final int             max_capacity;
    private final AtomicInteger   bytes=new AtomicInteger(0);
    private final Lock            lock=new ReentrantLock();
    private final Condition       full=lock.newCondition();
    private final Condition       empty=lock.newCondition();

    
    /**
     * @param max_capacity The max capacity in bytes
     */
    public MessageTransferQueue(int max_capacity) {
        this.max_capacity=max_capacity;
    }


    public int put(Message msg) {
        return 0;
    }

    public Message take() {
        return null;
    }

    public Message poll() {
        return null;
    }

}
